program Igrushka;

uses Crt, Dos;

label Exit,
      Resultat,
      Begin_Know;

type
  FrameIPXType=Record
    CheckSum:Word;
    Length:Word;
    TransportControl:Byte;
    PacketType:Byte;
    DestNetwork:LongInt;
    DestNode:Array[0..5] of Byte;
    DestSocket:Word;
    SourceNetwork:LongInt;
    SourceNode:Array[0..5] of Byte;
    SourceSocket:Word;
    Xnet:Byte;
    Ynet:Byte;
  end;
  ECBType=Record
    Link:LongInt;
    ESRAddress:LongInt;
    InUse:Byte;
    CCode:Byte;
    Socket:Word;
    IPXWorkSpace:LongInt;
    DriverWorkSpace:Array[0..11] of Byte;
    ImmAddress:Array[0..5] of Byte;
    FragmentCnt:Word;
    Offset:Word;
    Segment:Word;
    Size:Word;
  end;

var C:Char;
    X:Integer;
    Y:Integer;
    Xnet:Integer;
    Ynet:Integer;
    R:Registers;
    FrameIPXs,FrameIPXr:FrameIPXType;
    ECBs,ECBr:ECBType;
    Rax,Rbx,Rcx,Rdx,Rsi,Rdi,Res:Word;
    Ral:Byte;
    IPX_Entry:LongInt;
    i:Integer;

  procedure Call_API_IPX;
  begin
    asm
      push es
      push di
      push si
      push dx
      push cx
      push bx
      push ax

      mov es,Res
      mov di,Rdi
      mov si,Rsi
      mov dx,Rdx
      mov cx,Rcx
      mov bx,Rbx
      mov ax,Rax

      call [dword ptr IPX_Entry]

      mov Res,es
      mov Rdi,di
      mov Rsi,si
      mov Rdx,dx
      mov Rcx,cx
      mov Rbx,dx
      mov Rax,ax

      pop ax
      pop bx
      pop cx
      pop dx
      pop si
      pop di
      pop es
    end;
  end;

begin
  { ஢ઠ ⢨ IPX  । 窨 室  API IPX/SPX }
  asm
    push ax
    mov ax,7a00h
    int 2fh
    mov Ral,al
    pop ax
    mov word ptr IPX_Entry+2,es
    mov word ptr IPX_Entry,di
  end;
  if Ral<>$ff then
    begin
      WriteLn('IPX  㦥');
      Halt;
    end;

  Rbx:=0;     {  ᮪.}
  Rax:=$00ff;
  Rdx:=$4444;
  Call_API_IPX;
  Ral:=Rax mod 256;
  if Ral=0 then writeln(' ',Rdx,' .');
  if Ral=$ff then writeln(' ',Rdx,' 㦥   ࠭.');
  if Ral=$fe then writeln(' ᮪⮢ ९.');

 { 塞      ।.}
  FrameIPXs.PacketType:=4;
  FrameIPXs.DestNetwork:=0;
  FrameIPXs.DestNode[0]:=$ff;
  FrameIPXs.DestNode[1]:=$ff;
  FrameIPXs.DestNode[2]:=$ff;
  FrameIPXs.DestNode[3]:=$ff;
  FrameIPXs.DestNode[4]:=$ff;
  FrameIPXs.DestNode[5]:=$ff;
  FrameIPXs.DestSocket:=$4444;
  { 塞   ࠢ ᮡ⨥  ।.}
  ECBs.ESRAddress:=0;
  ECBs.Socket:=$4444;
  ECBs.ImmAddress[0]:=$ff;
  ECBs.ImmAddress[1]:=$ff;
  ECBs.ImmAddress[2]:=$ff;
  ECBs.ImmAddress[3]:=$ff;
  ECBs.ImmAddress[4]:=$ff;
  ECBs.ImmAddress[5]:=$ff;
  ECBs.FragmentCnt:=1;
  ECBs.Segment:=Seg(FrameIPXs);
  ECBs.Offset:=Ofs(FrameIPXs);
  ECBs.Size:=32;
  { 塞   ࠢ ᮡ⨥  ਥ.}
  ECBr.ESRAddress:=0;
  ECBr.Socket:=$4444;
  ECBr.FragmentCnt:=1;
  ECBr.Segment:=Seg(FrameIPXr);
  ECBr.Offset:=Ofs(FrameIPXr);
  ECBr.Size:=32;

{  稭 楤 ।  ᥤ.}
Begin_Know:

  { ⠢   ।  ਥ.}
  Rbx:=4;
  Res:=Seg(ECBr);
  Rsi:=Ofs(ECBr);
  Call_API_IPX;

  for i:=1 to 100 do
    begin
      {  IPX- .}
      Rbx:=$0a;
      Call_API_IPX;
      if KeyPressed=True then goto Exit;
      Delay(5);
      if ECBr.InUse=0 then goto Resultat;
    end;

  {    ।  ਥ.}
  Rbx:=6;
  Res:=Seg(ECBr);
  Rsi:=Ofs(ECBr);
  Call_API_IPX;
  while ECBr.InUse<>0 do
    begin
      {  IPX- .}
      Rbx:=$0a;
      Call_API_IPX;
      if KeyPressed=True then goto Exit;
    end;

  { । .}
  Rbx:=3;
  Res:=Seg(ECBs);
  Rsi:=Ofs(ECBs);
  Call_API_IPX;

  while ECBs.InUse<>0 do
    begin
      {  IPX- .}
      Rbx:=$0a;
      Call_API_IPX;
      if KeyPressed=True then goto Exit;
    end;

  goto Begin_Know;

Resultat:
  {  㤥 ।  ப⥫ .}
  for i:=0 to 5 do
    begin
      ECBs.ImmAddress[i]:=FrameIPXr.SourceNode[i];
      FrameIPXs.DestNode[i]:=FrameIPXr.SourceNode[i];
    end;
  { । 15 ⮢  1,5 ᥪ㭤.}
  for i:=1 to 15 do
  begin
    Rbx:=3;
    Res:=Seg(ECBs);
    Rsi:=Ofs(ECBs);
    Call_API_IPX;
    while ECBs.InUse<>0 do
      begin
        {  IPX- .}
        Rbx:=$0a;
        Call_API_IPX;
        if KeyPressed=True then goto Exit;
      end;
    Delay(100);
  end;

  {   ᥤ ।.  室  ECBs  FrameIPXs.}

  { 室 প  ६   祬  1,5 ᥪ㭤.}
  Delay(3000);
  { ⠢   ।  ਥ.}
  Rbx:=4;
  Res:=Seg(ECBr);
  Rsi:=Ofs(ECBr);
  Call_API_IPX;

  {   .}
  R.ah:=1;
  R.ch:=$20;
  intr($10,R);

  { 室 砫 ⠭.}
  ClrScr;
  Randomize;
  X:=Random(80)+1;
  Y:=Random(24)+1;
  GotoXY(X,Y);
  Write(Chr(1));
  Xnet:=1;
  Ynet:=1;

  repeat

    {    ,}
    {  室 ,}
    { ࠡ뢠 襤訩  - 㥬 ஦ ᥤ.}
    repeat
      begin
        {  IPX- .}
        Rbx:=$0a;
        Call_API_IPX;
        if ECBr.InUse=0 then
          begin
            GotoXY(Xnet,Ynet);
            Write(' ');
            Xnet:=FrameIPXr.Xnet;
            Ynet:=FrameIPXr.Ynet;
            GotoXY(Xnet,Ynet);
            Write(Chr(2));
            { ⠢   ।  ਥ.}
            Rbx:=4;
            Res:=Seg(ECBr);
            Rsi:=Ofs(ECBr);
            Call_API_IPX;
          end;
      end;
    until KeyPressed;

    C:=ReadKey;
    if Ord(C)=0 then C:=ReadKey;

    case Ord(C) of
      72:begin  { up }                  {   .}
           if Y<>1 then
             begin
               GotoXY(X,Y);
               Write(' ');
               Y:=Y-1;
               GotoXY(X,Y);
               Write(Chr(1));

               FrameIPXs.Xnet:=X;       { 뫠  ᥤ }
               FrameIPXs.Ynet:=Y;       {  न⠬ ᢮ ஦.}
               Rbx:=3;
               Res:=Seg(ECBs);
               Rsi:=Ofs(ECBs);
               Call_API_IPX;
               while ECBs.InUse<>0 do      {   楤 while - }
                 begin                     { .}
                   {  IPX- .}
                   Rbx:=$0a;
                   Call_API_IPX;
                 end;
             end;
         end;
      75:begin  { left }                {   .}
           if X<>1 then
             begin
               GotoXY(X,Y);
               Write(' ');
               X:=X-1;
               GotoXY(X,Y);
               Write(Chr(1));

               FrameIPXs.Xnet:=X;
               FrameIPXs.Ynet:=Y;
               Rbx:=3;
               Res:=Seg(ECBs);
               Rsi:=Ofs(ECBs);
               Call_API_IPX;
               while ECBs.InUse<>0 do
                 begin
                   {  IPX- .}
                   Rbx:=$0a;
                   Call_API_IPX;
                 end;
             end;
         end;
      77:begin  { right }               {   .}
           if X<>80 then
             begin
               GotoXY(X,Y);
               Write(' ');
               X:=X+1;
               GotoXY(X,Y);
               Write(Chr(1));

               FrameIPXs.Xnet:=X;
               FrameIPXs.Ynet:=Y;
               Rbx:=3;
               Res:=Seg(ECBs);
               Rsi:=Ofs(ECBs);
               Call_API_IPX;
               while ECBs.InUse<>0 do
                 begin
                   {  IPX- .}
                   Rbx:=$0a;
                   Call_API_IPX;
                 end;
             end;
         end;
      80:begin  { down }                {   .}
           if Y<>24 then
             begin
               GotoXY(X,Y);
               Write(' ');
               Y:=Y+1;
               GotoXY(X,Y);
               Write(Chr(1));

               FrameIPXs.Xnet:=X;
               FrameIPXs.Ynet:=Y;
               Rbx:=3;
               Res:=Seg(ECBs);
               Rsi:=Ofs(ECBs);
               Call_API_IPX;
               while ECBs.InUse<>0 do
                 begin
                   {  IPX- .}
                   Rbx:=$0a;
                   Call_API_IPX;
                 end;
           end;
         end;
    end;

  until Ord(C)=27;  { 室  Escape.}

Exit:
  Rbx:=1;    {  ᮪.}
  Rdx:=$4444;
  Call_API_IPX;
end.